library kitcod_uikit_flutter;

import "dart:convert";

import "package:assorted_layout_widgets/assorted_layout_widgets.dart";
import "package:audioplayers/audioplayers.dart";
import "package:carousel_slider/carousel_slider.dart";
import "package:chewie/chewie.dart";
import "package:flutter/material.dart";
import "package:flutter/services.dart";
import "package:flutter_share/flutter_share.dart";
import "package:http/http.dart" as http;
import "package:percent_indicator/percent_indicator.dart";
import "package:timeago/timeago.dart" as timeago;
import "package:url_launcher/link.dart";
import "package:url_launcher/url_launcher.dart";
import "package:video_player/video_player.dart";

part "ui_components/bottom_sheet/bottom_sheet.ui_component.dart";
part "ui_components/bottom_sheet/bottom_sheet_option.ui_component.dart";
part "ui_components/bottom_sheet/profile_bottom_sheet.ui_component.dart";
part "ui_components/bottom_sheet/bottom_sheet_navigation.ui_component.dart";
part "ui_components/bottom_sheet/bottom_sheet_dropdown.ui_component.dart";
part "ui_components/button/button.ui_component.dart";
part "ui_components/circular_widget/circlular_widget.ui_component.dart";
part "ui_components/comment/comment.ui_component.dart";
part "ui_components/feed_post/feed_post_card.ui_component.dart";
part "ui_components/feed_post/feed_post_details.ui_component.dart";
part "ui_components/feed_post/feed_post_list.ui_component.dart";
part "ui_components/groups/group_cards.ui_component.dart";
part "ui_components/groups/group_details.ui_component.dart";
part "ui_components/groups/group_page.ui_component.dart";
part "ui_components/groups/group_story.ui_component.dart";
part "ui_components/header_view/header_view.ui_component.dart";
part "ui_components/polls/polls.dart";
part "ui_components/polls/polls_view.ui_component.dart";
part "ui_components/profile_details/profile_details.ui_component.dart";
part "ui_components/share_stats_icons/share_stats_icons.ui_component.dart";
part "ui_components/text_bar/text_bar.ui_component.dart";
part "ui_components/text_bar/text_bar_button.ui_component.dart";
part "ui_components/video_widget/video_widget.ui_component.dart";
part "ui_components/text_icon_botton/text_icon_button.ui_component.dart";
part "ui_components/text_icon_botton/text_icon_button_detailed.ui_component.dart";
part "ui_components/comment_details/comment_details.ui_component.dart";

part "models/feed_group.model.dart";
part "models/feed_post.model.dart";
part "models/feed_post_api.model.dart";
part "models/group_api.model.dart";
part "models/comment.model.dart";
part "models/poll_details.model.dart";
part "models/profile_details.model.dart";
part "models/comment_reply.model.dart";
part "models/comment_api.model.dart";
part "models/user_profile_api.model.dart";

part "constants/colors.constant.dart";
part "constants/numerical.constant.dart";

part "styles/text_field.style.dart";

part "enums/enums.dart";

part "presentation/kitcod_icons.dart";

part "widgets/create_group/create_group.widget.dart";
part "widgets/create_group/create_group_setting.widget.dart";
part "widgets/create_group/create_group_community.widget.dart";
part "widgets/create_post.widget.dart";
part "widgets/groups.widget.dart";
part "widgets/my_groups.widget.dart";
part "widgets/news_feed.widget.dart";
part "widgets/user_profile_view.widget.dart";
part "widgets/discover_groups.widget.dart";
