// To parse this JSON data, do
//
//     final commentApi = commentApiFromJson(jsonString);

// ignore_for_file: sort_constructors_first, unnecessary_lambdas, avoid_dynamic_calls

part of kitcod_uikit_flutter;

CommentApi commentApiFromJson(final String str) =>
    CommentApi.fromJson(json.decode(str) as Map<String, dynamic>);

String commentApiToJson(final CommentApi data) => json.encode(data.toJson());

class CommentApi {
  CommentApi({
    required this.embeddedComment,
    required this.page,
  });

  EmbeddedComment embeddedComment;
  Page page;

  factory CommentApi.fromJson(final Map<String, dynamic> json) => CommentApi(
        embeddedComment: EmbeddedComment.fromJson(
            json["_embeddedt"] as Map<String, dynamic>),
        page: Page.fromJson(json["page"] as Map<String, dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "_embeddedComment": embeddedComment.toJson(),
        "page": page.toJson(),
      };
}

class EmbeddedComment {
  EmbeddedComment({
    required this.commentList,
  });

  List<CommentList> commentList;

  factory EmbeddedComment.fromJson(final Map<String, dynamic> json) =>
      EmbeddedComment(
        commentList: List<CommentList>.from(json["commentList"].map(
                (final x) => CommentList.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "commentList":
            List<dynamic>.from(commentList.map((final x) => x.toJson())),
      };
}

class CommentList {
  CommentList({
    required this.uuid,
    required this.createdTs,
    required this.updatedTs,
    required this.createdBy,
    required this.updatedBy,
    required this.version,
    required this.id,
    required this.resourceType,
    required this.resourceId,
    required this.userId,
    required this.communityId,
    required this.html,
    required this.active,
    this.interactionSummary,
  });

  String uuid;
  String createdTs;
  String updatedTs;
  String createdBy;
  String updatedBy;
  int version;
  String id;
  String resourceType;
  String resourceId;
  String userId;
  String communityId;
  String html;
  bool active;
  InteractionSummary? interactionSummary;

  factory CommentList.fromJson(final Map<String, dynamic> json) => CommentList(
        uuid: json["uuid"] as String,
        createdTs: json["createdTS"] as String,
        updatedTs: json["updatedTS"] as String,
        createdBy: json["createdBy"] as String,
        updatedBy: json["updatedBy"] as String,
        version: json["version"] as int,
        id: json["id"] as String,
        resourceType: json["resourceType"] as String,
        resourceId: json["resourceId"] as String,
        userId: json["userId"] as String,
        communityId: json["communityId"] as String,
        html: json["html"] as String,
        active: json["active"] as bool,
        interactionSummary: json["interactionSummary"] == null
            ? null
            : InteractionSummary.fromJson(
                json["interactionSummary"] as Map<String, dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "version": version,
        "id": id,
        "resourceType": resourceType,
        "resourceId": resourceId,
        "userId": userId,
        "communityId": communityId,
        "html": html,
        "active": active,
        "interactionSummaryComment": interactionSummary!.toJson(),
      };
}

class InteractionSummaryComments {
  InteractionSummaryComments({
    required this.interactionCounts,
    this.userInteractions,
  });

  factory InteractionSummaryComments.fromJson(
          final Map<String, dynamic> json) =>
      InteractionSummaryComments(
        interactionCounts:
            Map.from(json["interactionCounts"] as Map<String, dynamic>).map(
                (final k, final v) =>
                    MapEntry<String, int>(k as String, v as int)),
        userInteractions: json["userInteractions"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<UserInteraction>.from(json["userInteractions"].map(
                    (final x) =>
                        UserInteraction.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  Map<String, int> interactionCounts;
  List<UserInteraction>? userInteractions;

  Map<String, dynamic> toJson() => {
        "interactionCounts": Map.from(interactionCounts).map(
            (final k, final v) => MapEntry<String, dynamic>(k as String, v)),
        "userInteractions": userInteractions == null
            ? null
            : List<dynamic>.from(
                userInteractions!.map((final x) => x.toJson())),
      };
}

class CommentPage {
  CommentPage({
    required this.size,
    required this.totalElements,
    required this.totalPages,
    required this.number,
  });

  int size;
  int totalElements;
  int totalPages;
  int number;

  factory CommentPage.fromJson(final Map<String, dynamic> json) => CommentPage(
        size: json["size"] as int,
        totalElements: json["totalElements"] as int,
        totalPages: json["totalPages"] as int,
        number: json["number"] as int,
      );

  Map<String, dynamic> toJson() => {
        "size": size,
        "totalElements": totalElements,
        "totalPages": totalPages,
        "number": number,
      };
}
