// ignore_for_file: constant_identifier_names, unnecessary_lambdas

part of kitcod_uikit_flutter;

Postapi postapiFromJson(final String str) =>
    Postapi.fromJson(json.decode(str) as Map<String, dynamic>);

String postapiToJson(final Postapi data) => json.encode(data.toJson());

class Postapi {
  Postapi({
    required this.embedded,
    required this.links,
    required this.page,
  });

  factory Postapi.fromJson(final Map<String, dynamic> json) => Postapi(
        embedded: Embedded.fromJson(json["_embedded"] as Map<String, dynamic>),
        links: Links.fromJson(json["_links"] as Map<String, dynamic>),
        page: Page.fromJson(json["page"] as Map<String, dynamic>),
      );

  Embedded embedded;
  Links links;
  Page page;

  Map<String, dynamic> toJson() => {
        "_embedded": embedded.toJson(),
        "_links": links.toJson(),
        "page": page.toJson(),
      };
}

class Embedded {
  Embedded({
    required this.postList,
  });

  factory Embedded.fromJson(final Map<String, dynamic> json) => Embedded(
        postList: List<PostList>.from(
            // ignore: avoid_dynamic_calls
            json["postList"].map(PostList.fromJson) as Iterable<dynamic>),
      );

  List<PostList> postList;

  Map<String, dynamic> toJson() => {
        "postList": List<dynamic>.from(postList.map((final x) => x.toJson())),
      };
}

class PostList {
  PostList({
    required this.uuid,
    required this.createdTs,
    required this.updatedTs,
    required this.createdBy,
    required this.updatedBy,
    required this.version,
    required this.id,
    required this.title,
    this.contentHtml,
    this.contentMarkdown,
    this.postType,
    this.communityId,
    this.publishedTs,
    this.interactionSummary,
    this.communityContentVisibility,
    this.media,
    this.businessCommunity,
    this.active,
    this.poll,
    this.edited,
  });

  factory PostList.fromJson(final Map<String, dynamic> json) => PostList(
        uuid: json["uuid"] as String,
        createdTs: json["createdTS"] as String,
        updatedTs: json["updatedTS"] as String,
        createdBy: createdByValues.map[json["createdBy"]]!,
        updatedBy: createdByValues.map[json["updatedBy"]]!,
        version: json["version"] as int,
        id: json["id"] as String,
        title: json["title"] as String,
        contentHtml:
            json["contentHTML"] == null ? null : json["contentHTML"] as String,
        contentMarkdown: json["contentMarkdown"] == null
            ? null
            : json["contentMarkdown"] as String,
        postType: typeValues.map[json["postType"]],
        communityId: communityIdValues.map[json["communityId"]],
        publishedTs: json["publishedTS"] as String,
        interactionSummary: InteractionSummary.fromJson(
            json["interactionSummary"] as Map<String, dynamic>),
        communityContentVisibility: communityContentVisibilityValues
            .map[json["communityContentVisibility"]],
        media: Media.fromJson(json["media"] as Map<String, dynamic>),
        businessCommunity: json["businessCommunity"] as bool,
        active: json["active"] as bool,
        poll: json["poll"] == null
            ? null
            : Poll.fromJson(json["poll"] as Map<String, dynamic>),
        edited: json["edited"] == null ? null : json["edited"] as bool,
      );
  String uuid;
  String createdTs;
  String updatedTs;
  CreatedBy createdBy;
  CreatedBy updatedBy;
  int version;
  String id;
  String title;
  String? contentHtml;
  String? contentMarkdown;
  Type? postType;
  CommunityId? communityId;
  String? publishedTs;
  InteractionSummary? interactionSummary;
  CommunityContentVisibility? communityContentVisibility;
  Media? media;
  bool? businessCommunity;
  bool? active;
  Poll? poll;
  bool? edited;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdByValues.reverse[createdBy],
        "updatedBy": createdByValues.reverse[updatedBy],
        "version": version,
        "id": id,
        "title": title,
        "contentHTML": contentHtml ?? contentHtml,
        "contentMarkdown": contentMarkdown ?? contentMarkdown,
        "postType": typeValues.reverse[postType],
        "communityId": communityIdValues.reverse[communityId],
        "publishedTS": publishedTs,
        "interactionSummary": interactionSummary!.toJson(),
        "communityContentVisibility": communityContentVisibilityValues
            .reverse[communityContentVisibility],
        "media": media!.toJson(),
        "businessCommunity": businessCommunity,
        "active": active,
        "poll": poll == null ? null : poll!.toJson(),
        "edited": edited ?? edited,
      };
}

enum CommunityContentVisibility { private, public }

final communityContentVisibilityValues = EnumValues({
  "PRIVATE": CommunityContentVisibility.private,
  "PUBLIC": CommunityContentVisibility.public
});

enum CommunityId {
  THE_5_BC447519_F247_B5778_B024_EC,
  THE_5_CDE16_C19_F247_B6_C38753568,
  THE_601_EE39_AAC77_E1646_A92_B6_F1
}

final communityIdValues = EnumValues({
  "5bc447519f247b5778b024ec": CommunityId.THE_5_BC447519_F247_B5778_B024_EC,
  "5cde16c19f247b6c38753568": CommunityId.THE_5_CDE16_C19_F247_B6_C38753568,
  "601ee39aac77e1646a92b6f1": CommunityId.THE_601_EE39_AAC77_E1646_A92_B6_F1
});

enum CreatedBy {
  THE_5_B7_A7_A3_A9_F247_B0_F9_EF37595,
  THE_5_B741_FC79_F247_B0_F9_EF3756_E,
  THE_5_CDD40_D09_F247_B6_BF80_FC3_FA,
  THE_5_CEB14849_F247_B729_C3_D12_B4
}

final createdByValues = EnumValues({
  "5b741fc79f247b0f9ef3756e": CreatedBy.THE_5_B741_FC79_F247_B0_F9_EF3756_E,
  "5b7a7a3a9f247b0f9ef37595": CreatedBy.THE_5_B7_A7_A3_A9_F247_B0_F9_EF37595,
  "5cdd40d09f247b6bf80fc3fa": CreatedBy.THE_5_CDD40_D09_F247_B6_BF80_FC3_FA,
  "5ceb14849f247b729c3d12b4": CreatedBy.THE_5_CEB14849_F247_B729_C3_D12_B4
});

class InteractionSummary {
  InteractionSummary({
    required this.interactionCounts,
    this.userInteractions,
  });

  factory InteractionSummary.fromJson(final Map<String, dynamic> json) =>
      InteractionSummary(
        interactionCounts:
            Map.from(json["interactionCounts"] as Map<String, dynamic>).map(
                (final k, final v) =>
                    MapEntry<String, int>(k as String, v as int)),
        userInteractions: json["userInteractions"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<UserInteraction>.from(json["userInteractions"].map(
                    (final x) =>
                        UserInteraction.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  Map<String, int> interactionCounts;
  List<UserInteraction>? userInteractions;

  Map<String, dynamic> toJson() => {
        "interactionCounts": Map.from(interactionCounts).map(
            (final k, final v) => MapEntry<String, dynamic>(k as String, v)),
        "userInteractions": userInteractions == null
            ? null
            : List<dynamic>.from(
                userInteractions!.map((final x) => x.toJson())),
      };
}

class UserInteraction {
  UserInteraction({
    required this.uuid,
    required this.createdTs,
    required this.updatedTs,
    required this.version,
    required this.id,
    required this.interactionType,
    required this.resourceType,
    required this.resourceId,
    required this.resourceSubType,
    required this.userId,
    required this.count,
    required this.active,
  });

  factory UserInteraction.fromJson(final Map<String, dynamic> json) =>
      UserInteraction(
        uuid: json["uuid"] as String,
        createdTs: json["createdTS"] as String,
        updatedTs: json["updatedTS"] as String,
        version: json["version"] as int,
        id: json["id"] as String,
        interactionType: json["interactionType"] as String,
        resourceType: resourceTypeValues.map[json["resourceType"]]!,
        resourceId: json["resourceId"] as String,
        resourceSubType: typeValues.map[json["resourceSubType"]]!,
        userId: createdByValues.map[json["userId"]]!,
        count: json["count"] as int,
        active: json["active"] as bool,
      );

  String uuid;
  String createdTs;
  String updatedTs;
  int version;
  String id;
  String interactionType;
  ResourceType resourceType;
  String resourceId;
  Type resourceSubType;
  CreatedBy userId;
  int count;
  bool active;
  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "version": version,
        "id": id,
        "interactionType": interactionType,
        "resourceType": resourceTypeValues.reverse[resourceType],
        "resourceId": resourceId,
        "resourceSubType": typeValues.reverse[resourceSubType],
        "userId": createdByValues.reverse[userId],
        "count": count,
        "active": active,
      };
}

enum Type { ANNOUNCEMENT, POLL }

final typeValues =
    EnumValues({"ANNOUNCEMENT": Type.ANNOUNCEMENT, "POLL": Type.POLL});

enum ResourceType { POST }

final resourceTypeValues = EnumValues({"POST": ResourceType.POST});

class Media {
  Media({
    this.docs,
    this.auds,
    this.imgs,
  });

  factory Media.fromJson(final Map<String, dynamic> json) => Media(
        docs: json["docs"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<Aud>.from(json["docs"]
                    .map((final x) => Aud.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        auds: json["auds"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<Aud>.from(json["auds"]
                    .map((final x) => Aud.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        imgs: json["imgs"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<Aud>.from(json["imgs"]
                    .map((final x) => Aud.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  List<Aud>? docs;
  List<Aud>? auds;
  List<Aud>? imgs;

  Map<String, dynamic> toJson() => {
        "docs": docs == null
            ? null
            : List<dynamic>.from(docs!.map((final x) => x.toJson())),
        "auds": auds == null
            ? null
            : List<dynamic>.from(auds!.map((final x) => x.toJson())),
        "imgs": imgs == null
            ? null
            : List<dynamic>.from(imgs!.map((final x) => x.toJson())),
      };
}

class Aud {
  Aud({
    this.uuid,
    this.id,
    this.resourceType,
    this.resourceId,
    this.type,
    this.mediaUrl,
    this.contentType,
    this.active,
    this.displayRank,
    this.resizedMediaList,
  });

  factory Aud.fromJson(final Map<String, dynamic> json) => Aud(
        uuid: json["uuid"] as String,
        id: json["id"] as String,
        resourceType: resourceTypeValues.map[json["resourceType"]],
        resourceId: json["resourceId"] as String,
        type: audTypeValues.map[json["type"]],
        mediaUrl: json["mediaUrl"] == null ? null : json["mediaUrl"] as String,
        contentType: contentTypeValues.map[json["contentType"]],
        active: json["active"] as bool,
        displayRank:
            json["displayRank"] == null ? null : json["displayRank"] as int,
        resizedMediaList: json["resizedMediaList"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<ResizedMediaList>.from(json["resizedMediaList"].map(
                    (final x) =>
                        ResizedMediaList.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  String? uuid;
  String? id;
  ResourceType? resourceType;
  String? resourceId;
  AudType? type;
  String? mediaUrl;
  ContentType? contentType;
  bool? active;
  int? displayRank;
  List<ResizedMediaList>? resizedMediaList;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "id": id,
        "resourceType": resourceTypeValues.reverse[resourceType],
        "resourceId": resourceId,
        "type": audTypeValues.reverse[type],
        "mediaUrl": mediaUrl ?? mediaUrl,
        "contentType": contentTypeValues.reverse[contentType],
        "active": active,
        "displayRank": displayRank ?? displayRank,
        "resizedMediaList": resizedMediaList == null
            ? null
            : List<dynamic>.from(
                resizedMediaList!.map((final x) => x.toJson())),
      };
}

enum ContentType { MP3, PDF, JPG }

final contentTypeValues = EnumValues(
    {"jpg": ContentType.JPG, "mp3": ContentType.MP3, "pdf": ContentType.PDF});

class ResizedMediaList {
  ResizedMediaList({
    required this.type,
    required this.mediaUrl,
  });

  factory ResizedMediaList.fromJson(final Map<String, dynamic> json) =>
      ResizedMediaList(
        type: resizedMediaListTypeValues.map[json["type"]]!,
        mediaUrl: json["mediaUrl"] as String,
      );

  ResizedMediaListType type;
  String mediaUrl;

  Map<String, dynamic> toJson() => {
        "type": resizedMediaListTypeValues.reverse[type],
        "mediaUrl": mediaUrl,
      };
}

enum ResizedMediaListType { THUMBNAIL, RESIZED }

final resizedMediaListTypeValues = EnumValues({
  "resized": ResizedMediaListType.RESIZED,
  "thumbnail": ResizedMediaListType.THUMBNAIL
});

enum AudType { COMMUNITY_AUDIO, COMMUNITY_DOCUMENT, COMMUNITY_PIC }

final audTypeValues = EnumValues({
  "CommunityAudio": AudType.COMMUNITY_AUDIO,
  "CommunityDocument": AudType.COMMUNITY_DOCUMENT,
  "CommunityPic": AudType.COMMUNITY_PIC
});

class Poll {
  Poll({
    required this.options,
    this.endDateTime,
    this.timeZoneId,
    this.timeZoneOffset,
  });

  factory Poll.fromJson(final Map<String, dynamic> json) => Poll(
        // ignore: avoid_dynamic_calls
        options: List<Option>.from(json["options"]
                .map((final x) => Option.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
        endDateTime:
            json["endDateTime"] == null ? null : json["endDateTime"] as String,
        timeZoneId:
            json["timeZoneId"] == null ? null : json["timeZoneId"] as String,
        timeZoneOffset: json["timeZoneOffset"] == null
            ? null
            : json["timeZoneOffset"] as String,
      );

  List<Option> options;
  String? endDateTime;
  String? timeZoneId;
  String? timeZoneOffset;

  Map<String, dynamic> toJson() => {
        "options": List<dynamic>.from(options.map((final x) => x.toJson())),
        "endDateTime": endDateTime ?? endDateTime,
        "timeZoneId": timeZoneId ?? timeZoneId,
        "timeZoneOffset": timeZoneOffset ?? timeZoneOffset,
      };
}

class Option {
  Option({
    required this.type,
    required this.text,
  });

  factory Option.fromJson(final Map<String, dynamic> json) => Option(
        type: json["type"] as String,
        text: json["text"] as String,
      );

  String type;
  String text;

  Map<String, dynamic> toJson() => {
        "type": type,
        "text": text,
      };
}

class Links {
  Links({
    required this.next,
    required this.last,
  });

  factory Links.fromJson(final Map<String, dynamic> json) => Links(
        next: Last.fromJson(json["next"] as Map<String, dynamic>),
        last: Last.fromJson(json["last"] as Map<String, dynamic>),
      );

  Last next;
  Last last;

  Map<String, dynamic> toJson() => {
        "next": next.toJson(),
        "last": last.toJson(),
      };
}

class Last {
  Last({
    required this.href,
  });

  factory Last.fromJson(final Map<String, dynamic> json) => Last(
        href: json["href"] as String,
      );

  String href;

  Map<String, dynamic> toJson() => {
        "href": href,
      };
}

class Page {
  Page({
    required this.size,
    required this.totalElements,
    required this.totalPages,
    required this.number,
  });

  factory Page.fromJson(final Map<String, dynamic> json) => Page(
        size: json["size"] as int,
        totalElements: json["totalElements"] as int,
        totalPages: json["totalPages"] as int,
        number: json["number"] as int,
      );

  int size;
  int totalElements;
  int totalPages;
  int number;

  Map<String, dynamic> toJson() => {
        "size": size,
        "totalElements": totalElements,
        "totalPages": totalPages,
        "number": number,
      };
}

class EnumValues<T> {
  Map<String, T> map;
  Map<T, String> reverseMap = {};

  // ignore: sort_constructors_first
  EnumValues(this.map);

  Map<T, String> get reverse {
    // ignore: prefer_conditional_assignment
    if (reverseMap == null) {
      reverseMap = map.map((final k, final v) => MapEntry(v, k));
    }
    return reverseMap;
  }
}
