// ignore_for_file: sort_constructors_first, avoid_dynamic_calls, unnecessary_lambdas, constant_identifier_names, prefer_if_null_operators, avoid_unused_constructor_parameters

part of kitcod_uikit_flutter;

UserProfile userProfileFromJson(final String str) =>
    UserProfile.fromJson(json.decode(str) as Map<String, dynamic>);

String userProfileToJson(final UserProfile data) => json.encode(data.toJson());

class UserProfile {
  UserProfile({
    this.uuid,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.version,
    this.id,
    this.media,
    this.firstName,
    this.lastName,
    this.gender,
    this.yob,
    this.authProviders,
    this.homeLocation,
    this.contactPoints,
    this.premiumUntilTs,
    this.type,
    this.metadata,
    this.registeredTs,
    this.devices,
    this.userCommunities,
    this.userCommunitiesNegative,
    this.policyAcceptances,
    this.active,
  });

  String? uuid;
  String? createdTs;
  String? updatedTs;
  CreatedBy? createdBy;
  CreatedBy? updatedBy;
  int? version;
  CreatedBy? id;
  UserProfileMedia? media;
  String? firstName;
  String? lastName;
  int? gender;
  int? yob;
  List<AuthProvider>? authProviders;
  HomeLocation? homeLocation;
  List<ContactPoint>? contactPoints;
  String? premiumUntilTs;
  String? type;
  UserProfileMetadata? metadata;
  String? registeredTs;
  List<Device>? devices;
  List<UserCommunit>? userCommunities;
  List<UserCommunit>? userCommunitiesNegative;
  List<PolicyAcceptance>? policyAcceptances;
  bool? active;

  factory UserProfile.fromJson(final Map<String, dynamic> json) => UserProfile(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: createdByValues.map[json["createdBy"]],
        updatedBy: createdByValues.map[json["updatedBy"]],
        version: json["version"] as int?,
        id: createdByValues.map[json["id"]],
        media: UserProfileMedia.fromJson(json["media"] as Map<String, dynamic>),
        firstName: json["firstName"] as String?,
        lastName: json["lastName"] as String?,
        gender: json["gender"] as int?,
        yob: json["yob"] as int?,
        authProviders: List<AuthProvider>.from(json["authProviders"].map(
                (final x) => AuthProvider.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
        homeLocation:
            HomeLocation.fromJson(json["homeLocation"] as Map<String, dynamic>),
        contactPoints: List<ContactPoint>.from(json["contactPoints"].map(
                (final x) => ContactPoint.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
        premiumUntilTs: json["premiumUntilTS"] as String?,
        type: json["type"] as String?,
        metadata: UserProfileMetadata.fromJson(
            json["metadata"] as Map<String, dynamic>),
        registeredTs: json["registeredTS"] as String?,
        devices: List<Device>.from(json["devices"]
                .map((final x) => Device.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
        userCommunities: List<UserCommunit>.from(json["userCommunities"].map(
                (final x) => UserCommunit.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
        userCommunitiesNegative: List<UserCommunit>.from(
            json["userCommunitiesNegative"].map((final x) =>
                    UserCommunit.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        policyAcceptances: List<PolicyAcceptance>.from(json["policyAcceptances"]
                .map((final x) =>
                    PolicyAcceptance.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
        active: json["active"] as bool?,
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdByValues.reverse[createdBy],
        "updatedBy": createdByValues.reverse[updatedBy],
        "version": version,
        "id": createdByValues.reverse[id],
        "media": media!.toJson(),
        "firstName": firstName,
        "lastName": lastName,
        "gender": gender,
        "yob": yob,
        "authProviders":
            List<dynamic>.from(authProviders!.map((final x) => x.toJson())),
        "homeLocation": homeLocation!.toJson(),
        "contactPoints":
            List<dynamic>.from(contactPoints!.map((final x) => x.toJson())),
        "premiumUntilTS": premiumUntilTs,
        "type": type,
        "metadata": metadata!.toJson(),
        "registeredTS": registeredTs,
        "devices": List<dynamic>.from(devices!.map((final x) => x.toJson())),
        "userCommunities":
            List<dynamic>.from(userCommunities!.map((final x) => x.toJson())),
        "userCommunitiesNegative": List<dynamic>.from(
            userCommunitiesNegative!.map((final x) => x.toJson())),
        "policyAcceptances":
            List<dynamic>.from(policyAcceptances!.map((final x) => x.toJson())),
        "active": active,
      };
}

class AuthProvider {
  AuthProvider({
    this.authProvider,
    this.authUserId,
  });

  String? authProvider;
  String? authUserId;

  factory AuthProvider.fromJson(final Map<String, dynamic> json) =>
      AuthProvider(
        authProvider: json["authProvider"] as String,
        authUserId: json["authUserId"] as String,
      );

  Map<String, dynamic> toJson() => {
        "authProvider": authProvider,
        "authUserId": authUserId,
      };
}

class ContactPoint {
  ContactPoint({
    this.type,
    this.value,
  });

  String? type;
  String? value;

  factory ContactPoint.fromJson(final Map<String, dynamic> json) =>
      ContactPoint(
        type: json["type"] as String,
        value: json["value"] as String,
      );

  Map<String, dynamic> toJson() => {
        "type": type,
        "value": value,
      };
}

enum CreatedByEnum { THE_5_B7_A7_A3_A9_F247_B0_F9_EF37595 }

final createdByValuesEnum = EnumValues({
  "5b7a7a3a9f247b0f9ef37595": CreatedBy.THE_5_B7_A7_A3_A9_F247_B0_F9_EF37595
});

class Device {
  Device({
    this.uuid,
    this.osType,
    this.osVersion,
    this.deviceMake,
    this.deviceVersion,
    this.ppEndPointId,
    this.adTrackingDisabled,
    this.active,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.deviceType,
    this.deviceAdvertisingId,
    this.ppDeviceToken,
    this.deviceName,
  });

  String? uuid;
  OsType? osType;
  String? osVersion;
  DeviceMake? deviceMake;
  String? deviceVersion;
  String? ppEndPointId;
  bool? adTrackingDisabled;
  bool? active;
  String? createdTs;
  String? updatedTs;
  CreatedBy? createdBy;
  CreatedBy? updatedBy;
  DeviceType? deviceType;
  String? deviceAdvertisingId;
  String? ppDeviceToken;
  DeviceName? deviceName;

  factory Device.fromJson(final Map<String, dynamic> json) => Device(
        uuid: json["uuid"] as String?,
        osType: osTypeValues.map[json["osType"]],
        osVersion: json["osVersion"] as String?,
        deviceMake: deviceMakeValues.map[json["deviceMake"]],
        deviceVersion: json["deviceVersion"] == null
            ? null
            : json["deviceVersion"] as String?,
        ppEndPointId: json["ppEndPointId"] as String?,
        adTrackingDisabled: json["adTrackingDisabled"] == null
            ? null
            : json["adTrackingDisabled"] as bool?,
        active: json["active"] as bool?,
        createdTs:
            json["createdTS"] == null ? null : json["createdTS"] as String?,
        updatedTs:
            json["updatedTS"] == null ? null : json["updatedTS"] as String?,
        createdBy: json["createdBy"] == null
            ? null
            : createdByValues.map[json["createdBy"]],
        updatedBy: json["updatedBy"] == null
            ? null
            : createdByValues.map[json["updatedBy"]],
        deviceType: json["deviceType"] == null
            ? null
            : deviceTypeValues.map[json["deviceType"]],
        deviceAdvertisingId: json["deviceAdvertisingId"] == null
            ? null
            : json["deviceAdvertisingId"] as String,
        ppDeviceToken: json["ppDeviceToken"] == null
            ? null
            : json["ppDeviceToken"] as String,
        deviceName: json["deviceName"] == null
            ? null
            : deviceNameValues.map[json["deviceName"]],
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "osType": osTypeValues.reverse[osType],
        "osVersion": osVersion,
        "deviceMake": deviceMakeValues.reverse[deviceMake],
        "deviceVersion": deviceVersion == null ? null : deviceVersion,
        "ppEndPointId": ppEndPointId,
        "adTrackingDisabled":
            adTrackingDisabled == null ? null : adTrackingDisabled,
        "active": active,
        "createdTS": createdTs == null ? null : createdTs,
        "updatedTS": updatedTs == null ? null : updatedTs,
        "createdBy":
            createdBy == null ? null : createdByValues.reverse[createdBy],
        "updatedBy":
            updatedBy == null ? null : createdByValues.reverse[updatedBy],
        "deviceType":
            deviceType == null ? null : deviceTypeValues.reverse[deviceType],
        "deviceAdvertisingId":
            deviceAdvertisingId == null ? null : deviceAdvertisingId,
        "ppDeviceToken": ppDeviceToken == null ? null : ppDeviceToken,
        "deviceName":
            deviceName == null ? null : deviceNameValues.reverse[deviceName],
      };
}

enum DeviceMake { XIAOMI, APPLE, MOTOROLA }

final deviceMakeValues = EnumValues({
  "Apple": DeviceMake.APPLE,
  "motorola": DeviceMake.MOTOROLA,
  "Xiaomi": DeviceMake.XIAOMI
});

enum DeviceName { XIAOMI_REDMI_6_PRO, XIAOMI_REDMI_5_A, MOTOROLA_MOTO_G_6 }

final deviceNameValues = EnumValues({
  "motorola moto g(6)": DeviceName.MOTOROLA_MOTO_G_6,
  "Xiaomi Redmi 5A": DeviceName.XIAOMI_REDMI_5_A,
  "Xiaomi Redmi 6 Pro": DeviceName.XIAOMI_REDMI_6_PRO
});

enum DeviceType { I_PHONE, PHONE }

final deviceTypeValues =
    EnumValues({"iPhone": DeviceType.I_PHONE, "PHONE": DeviceType.PHONE});

enum OsType { ANDROID, I_OS }

final osTypeValues =
    EnumValues({"Android": OsType.ANDROID, "iOS": OsType.I_OS});

class HomeLocation {
  HomeLocation({
    this.uuid,
    this.address,
    this.active,
  });

  String? uuid;
  HomeLocationAddress? address;
  bool? active;

  factory HomeLocation.fromJson(final Map<String, dynamic> json) =>
      HomeLocation(
        uuid: json["uuid"] as String,
        address: HomeLocationAddress.fromJson(
            json["address"] as Map<String, dynamic>),
        active: json["active"] as bool,
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "address": address!.toJson(),
        "active": active,
      };
}

class HomeLocationAddress {
  HomeLocationAddress({
    this.uuid,
    this.city,
    this.state,
    this.country,
    this.zipcode,
    this.active,
  });

  String? uuid;
  String? city;
  String? state;
  String? country;
  String? zipcode;
  bool? active;

  factory HomeLocationAddress.fromJson(final Map<String, dynamic> json) =>
      HomeLocationAddress(
        uuid: json["uuid"] as String,
        city: json["city"] as String,
        state: json["state"] as String,
        country: json["country"] as String,
        zipcode: json["zipcode"] as String,
        active: json["active"] as bool,
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "city": city,
        "state": state,
        "country": country,
        "zipcode": zipcode,
        "active": active,
      };
}

class UserProfileMedia {
  UserProfileMedia({
    this.proImg,
  });

  Img? proImg;

  factory UserProfileMedia.fromJson(final Map<String, dynamic> json) =>
      UserProfileMedia(
        proImg: Img.fromJson(json["proImg"] as Map<String, dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "proImg": proImg!.toJson(),
      };
}

// class Img {
//   Img({
//     this.uuid,
//     this.id,
//     this.resourceType,
//     this.resourceId,
//     this.type,
//     this.contentType,
//     this.resizedMediaList,
//     this.active,
//   });

//   String uuid;
//   String id;
//   String resourceType;
//   String resourceId;
//   String type;
//   String contentType;
//   List<ResizedMediaList> resizedMediaList;
//   bool active;

//   factory Img.fromJson(final Map<String, dynamic> json) => Img(
//         uuid: json["uuid"],
//         id: json["id"],
//         resourceType: json["resourceType"],
//         resourceId: json["resourceId"],
//         type: json["type"],
//         contentType: json["contentType"],
//         resizedMediaList: List<ResizedMediaList>.from(json["resizedMediaList"]
//             .map((final x) => ResizedMediaList.fromJson(x))),
//         active: json["active"],
//       );

//   Map<String, dynamic> toJson() => {
//         "uuid": uuid,
//         "id": id,
//         "resourceType": resourceType,
//         "resourceId": resourceId,
//         "type": type,
//         "contentType": contentType,
//         "resizedMediaList":
//             List<dynamic>.from(resizedMediaList.map((final x) => x.toJson())),
//         "active": active,
//       };
// }

// class ResizedMediaList {
//   ResizedMediaList({
//     this.type,
//     this.mediaUrl,
//   });

//   Type type;
//   String mediaUrl;

//   factory ResizedMediaList.fromJson(final Map<String, dynamic> json) =>
//       ResizedMediaList(
//         type: typeValues.map[json["type"]],
//         mediaUrl: json["mediaUrl"],
//       );

//   Map<String, dynamic> toJson() => {
//         "type": typeValues.reverse[type],
//         "mediaUrl": mediaUrl,
//       };
// }

enum TypeEnum { THUMBNAIL, RESIZED }

final typeValuesEnum =
    EnumValues({"resized": TypeEnum.RESIZED, "thumbnail": TypeEnum.THUMBNAIL});

class UserProfileMetadata {
  UserProfileMetadata({
    this.mdChatUser,
  });

  MdChatUser? mdChatUser;

  factory UserProfileMetadata.fromJson(final Map<String, dynamic> json) =>
      UserProfileMetadata(
        mdChatUser:
            MdChatUser.fromJson(json["mdChatUser"] as Map<String, dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "mdChatUser": mdChatUser!.toJson(),
      };
}

class MdChatUser {
  MdChatUser({
    this.userId,
    this.nickname,
    this.profileUrl,
    this.phoneNumber,
    this.discoveryKeys,
    this.metadata,
    this.isActive,
    this.hasEverLoggedIn,
    this.isOnline,
    this.lastSeenAt,
    this.sessionToken,
    this.updatedTs,
    this.updatedBy,
    this.version,
  });

  String? userId;
  String? nickname;
  String? profileUrl;
  String? phoneNumber;
  List<dynamic>? discoveryKeys;
  MdChatUserMetadata? metadata;
  bool? isActive;
  bool? hasEverLoggedIn;
  bool? isOnline;
  int? lastSeenAt;
  SessionToken? sessionToken;
  String? updatedTs;
  CreatedBy? updatedBy;
  int? version;

  factory MdChatUser.fromJson(final Map<String, dynamic> json) => MdChatUser(
        userId: json["user_id"] as String,
        nickname: json["nickname"] as String,
        profileUrl: json["profile_url"] as String,
        phoneNumber: json["phone_number"] as String,
        discoveryKeys: List<dynamic>.from(
            json["discovery_keys"].map((final x) => x) as Iterable<dynamic>),
        metadata: MdChatUserMetadata.fromJson(
            json["metadata"] as Map<String, dynamic>),
        isActive: json["is_active"] as bool,
        hasEverLoggedIn: json["has_ever_logged_in"] as bool,
        isOnline: json["is_online"] as bool,
        lastSeenAt: json["last_seen_at"] as int,
        sessionToken: SessionToken.fromJson(
            json["session_token"] as Map<String, dynamic>),
        updatedTs: json["updated_ts"] as String,
        updatedBy: createdByValues.map[json["updated_by"]],
        version: json["version"] as int,
      );

  Map<String, dynamic> toJson() => {
        "user_id": userId,
        "nickname": nickname,
        "profile_url": profileUrl,
        "phone_number": phoneNumber,
        "discovery_keys":
            List<dynamic>.from(discoveryKeys!.map((final x) => x)),
        "metadata": metadata!.toJson(),
        "is_active": isActive,
        "has_ever_logged_in": hasEverLoggedIn,
        "is_online": isOnline,
        "last_seen_at": lastSeenAt,
        "session_token": sessionToken!.toJson(),
        "updated_ts": updatedTs,
        "updated_by": createdByValues.reverse[updatedBy],
        "version": version,
      };
}

class MdChatUserMetadata {
  MdChatUserMetadata({
    this.homeCountry,
  });

  String? homeCountry;

  factory MdChatUserMetadata.fromJson(final Map<String, dynamic> json) =>
      MdChatUserMetadata(
        homeCountry: json["homeCountry"] as String,
      );

  Map<String, dynamic> toJson() => {
        "homeCountry": homeCountry,
      };
}

class SessionToken {
  SessionToken({
    this.expiresAt,
    this.sessionToken,
  });

  int? expiresAt;
  String? sessionToken;

  factory SessionToken.fromJson(final Map<String, dynamic> json) =>
      SessionToken(
        expiresAt: json["expires_at"] as int,
        sessionToken: json["session_token"] as String,
      );

  Map<String, dynamic> toJson() => {
        "expires_at": expiresAt,
        "session_token": sessionToken,
      };
}

class PolicyAcceptance {
  PolicyAcceptance({
    this.policyType,
    this.language,
    this.policyDocVersion,
    this.acceptedTs,
    this.ipAddress,
    this.latest,
  });

  String? policyType;
  String? language;
  String? policyDocVersion;
  String? acceptedTs;
  String? ipAddress;
  bool? latest;

  factory PolicyAcceptance.fromJson(final Map<String, dynamic> json) =>
      PolicyAcceptance(
        policyType: json["policyType"] as String?,
        language: json["language"] as String?,
        policyDocVersion: json["policyDocVersion"] as String?,
        acceptedTs: json["acceptedTS"] as String?,
        ipAddress: json["ipAddress"] as String?,
        latest: json["latest"] as bool?,
      );

  Map<String, dynamic> toJson() => {
        "policyType": policyType,
        "language": language,
        "policyDocVersion": policyDocVersion,
        "acceptedTS": acceptedTs,
        "ipAddress": ipAddress,
        "latest": latest,
      };
}

class UserCommunit {
  UserCommunit({
    this.uuid,
    this.userId,
    this.communityId,
    this.status,
    this.userCommunityRoles,
    this.community,
    this.eligibility,
    this.businessCommunity,
    this.metadata,
  });

  String? uuid;
  CreatedBy? userId;
  String? communityId;
  Status? status;
  List<UserCommunityRole>? userCommunityRoles;
  Community? community;
  UserEligibility? eligibility;
  bool? businessCommunity;
  UserCommunityMetadata? metadata;

  factory UserCommunit.fromJson(final Map<String, dynamic> json) =>
      UserCommunit(
        uuid: json["uuid"] as String?,
        userId: createdByValues.map[json["userId"]],
        communityId: json["communityId"] as String?,
        status: statusValues.map[json["status"]],
        userCommunityRoles: json["userCommunityRoles"] == null
            ? null
            : List<UserCommunityRole>.from(json["userCommunityRoles"].map(
                    (final x) =>
                        UserCommunityRole.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        community: json["community"] == null
            ? null
            : Community.fromJson(json["community"] as Map<String, dynamic>),
        eligibility: UserEligibility.fromJson(
            json["eligibility"] as Map<String, dynamic>),
        businessCommunity: json["businessCommunity"] as bool?,
        metadata: json["metadata"] == null
            ? null
            : UserCommunityMetadata.fromJson(
                json["metadata"] as Map<String, dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "userId": createdByValues.reverse[userId],
        "communityId": communityId,
        "status": statusValues.reverse[status],
        "userCommunityRoles": userCommunityRoles == null
            ? null
            : List<dynamic>.from(
                userCommunityRoles!.map((final x) => x.toJson())),
        "community": community == null ? null : community!.toJson(),
        "eligibility": eligibility!.toJson(),
        "businessCommunity": businessCommunity,
        "metadata": metadata == null ? null : metadata!.toJson(),
      };
}

class Community {
  Community({
    this.uuid,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.version,
    this.id,
    this.accountId,
    this.name,
    this.description,
    this.sect,
    this.handle,
    this.communityType,
    this.location,
    this.webSiteUrl,
    this.links,
    this.operatingSchedule,
    this.contactPoints,
    this.facilities,
    this.status,
    this.contentVisibilityType,
    this.settings,
    this.media,
    this.eligibility,
    this.hidden,
    this.business,
    this.verified,
    this.premium,
    this.active,
    this.creationSourceType,
    this.rangeMembersCount,
    this.tags,
  });

  String? uuid;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  int? version;
  String? id;
  int? accountId;
  String? name;
  String? description;
  String? sect;
  String? handle;
  String? communityType;
  Location? location;
  String? webSiteUrl;
  UserLinks? links;
  OperatingSchedule? operatingSchedule;
  List<ContactPoint>? contactPoints;
  List<Facility>? facilities;
  String? status;
  String? contentVisibilityType;
  List<Setting>? settings;
  CommunityMedia? media;
  UserEligibility? eligibility;
  bool? hidden;
  bool? business;
  bool? verified;
  bool? premium;
  bool? active;
  String? creationSourceType;
  int? rangeMembersCount;
  List<Tag>? tags;

  factory Community.fromJson(final Map<String, dynamic> json) => Community(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: json["createdBy"] as String?,
        updatedBy: json["updatedBy"] as String?,
        version: json["version"] as int?,
        id: json["id"] as String?,
        accountId: json["accountId"] as int?,
        name: json["name"] as String?,
        description: json["description"] as String?,
        sect: json["sect"] as String?,
        handle: json["handle"] as String?,
        communityType: json["communityType"] as String?,
        location: Location.fromJson(json["location"] as Map<String, dynamic>),
        webSiteUrl:
            json["webSiteUrl"] == null ? null : json["webSiteUrl"] as String,
        links: json["links"] == null
            ? null
            : UserLinks.fromJson(json["links"] as Map<String, dynamic>),
        operatingSchedule: json["operatingSchedule"] == null
            ? null
            : OperatingSchedule.fromJson(
                json["operatingSchedule"] as Map<String, dynamic>),
        contactPoints: List<ContactPoint>.from(json["contactPoints"].map(
                (final x) => ContactPoint.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
        facilities: List<Facility>.from(json["facilities"]
                .map((final x) => Facility.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
        status: json["status"] as String,
        contentVisibilityType: json["contentVisibilityType"] as String,
        settings: List<Setting>.from(json["settings"]
                .map((final x) => Setting.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
        media: CommunityMedia.fromJson(json["media"] as Map<String, dynamic>),
        eligibility: UserEligibility.fromJson(
            json["eligibility"] as Map<String, dynamic>),
        hidden: json["hidden"] as bool?,
        business: json["business"] as bool?,
        verified: json["verified"] as bool?,
        premium: json["premium"] as bool?,
        active: json["active"] as bool?,
        creationSourceType: json["creationSourceType"] == null
            ? null
            : json["creationSourceType"] as String,
        rangeMembersCount: json["rangeMembersCount"] == null
            ? null
            : json["rangeMembersCount"] as int,
        tags: json["tags"] == null
            ? null
            : List<Tag>.from(json["tags"]
                    .map((final x) => Tag.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "version": version,
        "id": id,
        "accountId": accountId,
        "name": name,
        "description": description,
        "sect": sect,
        "handle": handle,
        "communityType": communityType,
        "location": location!.toJson(),
        "webSiteUrl": webSiteUrl == null ? null : webSiteUrl,
        "links": links == null ? null : links!.toJson(),
        "operatingSchedule":
            operatingSchedule == null ? null : operatingSchedule!.toJson(),
        "contactPoints":
            List<dynamic>.from(contactPoints!.map((final x) => x.toJson())),
        "facilities":
            List<dynamic>.from(facilities!.map((final x) => x.toJson())),
        "status": status,
        "contentVisibilityType": contentVisibilityType,
        "settings": List<dynamic>.from(settings!.map((final x) => x.toJson())),
        "media": media!.toJson(),
        "eligibility": eligibility!.toJson(),
        "hidden": hidden,
        "business": business,
        "verified": verified,
        "premium": premium,
        "active": active,
        "creationSourceType":
            creationSourceType == null ? null : creationSourceType,
        "rangeMembersCount":
            rangeMembersCount == null ? null : rangeMembersCount,
        "tags": tags == null
            ? null
            : List<dynamic>.from(tags!.map((final x) => x.toJson())),
      };
}

class UserEligibility {
  UserEligibility();

  factory UserEligibility.fromJson(final Map<String, dynamic> json) =>
      UserEligibility();

  Map<String, dynamic> toJson() => {};
}

// class Facility {
//   Facility({
//     this.uuid,
//     this.description,
//     this.type,
//     this.active,
//   });

//   String uuid;
//   String description;
//   String type;
//   bool active;

//   factory Facility.fromJson(final Map<String, dynamic> json) => Facility(
//         uuid: json["uuid"],
//         description: json["description"],
//         type: json["type"],
//         active: json["active"],
//       );

//   Map<String, dynamic> toJson() => {
//         "uuid": uuid,
//         "description": description,
//         "type": type,
//         "active": active,
//       };
// }

class UserLinks {
  UserLinks({
    this.invite,
  });

  String? invite;

  factory UserLinks.fromJson(final Map<String, dynamic> json) => UserLinks(
        invite: json["invite"] as String?,
      );

  Map<String, dynamic> toJson() => {
        "invite": invite,
      };
}

// class Location {
//   Location({
//     this.uuid,
//     this.geoCoordinates,
//     this.address,
//     this.gplaceId,
//     this.active,
//     this.version,
//   });

//   String uuid;
//   GeoCoordinates geoCoordinates;
//   LocationAddress address;
//   String gplaceId;
//   bool active;
//   int version;

//   factory Location.fromJson(final Map<String, dynamic> json) => Location(
//         uuid: json["uuid"],
//         geoCoordinates: GeoCoordinates.fromJson(json["geoCoordinates"]),
//         address: LocationAddress.fromJson(json["address"]),
//         gplaceId: json["gplaceId"],
//         active: json["active"],
//         version: json["version"] == null ? null : json["version"],
//       );

//   Map<String, dynamic> toJson() => {
//         "uuid": uuid,
//         "geoCoordinates": geoCoordinates.toJson(),
//         "address": address.toJson(),
//         "gplaceId": gplaceId,
//         "active": active,
//         "version": version == null ? null : version,
//       };
// }

class LocationAddress {
  LocationAddress({
    this.uuid,
    this.addressLine1,
    this.displayAddressLine,
    this.city,
    this.country,
    this.zipcode,
    this.active,
    this.version,
    this.state,
  });

  String? uuid;
  String? addressLine1;
  String? displayAddressLine;
  String? city;
  String? country;
  String? zipcode;
  bool? active;
  int? version;
  String? state;

  factory LocationAddress.fromJson(final Map<String, dynamic> json) =>
      LocationAddress(
        uuid: json["uuid"] as String,
        addressLine1: json["addressLine1"] as String,
        displayAddressLine: json["displayAddressLine"] as String,
        city: json["city"] as String,
        country: json["country"] as String,
        zipcode: json["zipcode"] as String,
        active: json["active"] as bool,
        version: json["version"] == null ? null : json["version"] as int,
        state: json["state"] == null ? null : json["state"] as String,
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "addressLine1": addressLine1,
        "displayAddressLine": displayAddressLine,
        "city": city,
        "country": country,
        "zipcode": zipcode,
        "active": active,
        "version": version == null ? null : version,
        "state": state == null ? null : state,
      };
}

// class GeoCoordinates {
//   GeoCoordinates({
//     this.type,
//     this.coordinates,
//     this.latitude,
//     this.longitude,
//   });

//   String type;
//   List<double> coordinates;
//   String latitude;
//   String longitude;

//   factory GeoCoordinates.fromJson(final Map<String, dynamic> json) =>
//       GeoCoordinates(
//         type: json["type"],
//         coordinates: List<double>.from(
//             json["coordinates"].map((final x) => x.toDouble())),
//         latitude: json["latitude"],
//         longitude: json["longitude"],
//       );

//   Map<String, dynamic> toJson() => {
//         "type": type,
//         "coordinates": List<dynamic>.from(coordinates.map((final x) => x)),
//         "latitude": latitude,
//         "longitude": longitude,
//       };
// }

class CommunityMedia {
  CommunityMedia({
    this.proImg,
    this.covImg,
  });

  Img? proImg;
  Img? covImg;

  factory CommunityMedia.fromJson(final Map<String, dynamic> json) =>
      CommunityMedia(
        proImg: Img.fromJson(json["proImg"] as Map<String, dynamic>),
        covImg: Img.fromJson(json["covImg"] as Map<String, dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "proImg": proImg!.toJson(),
        "covImg": covImg!.toJson(),
      };
}

class OperatingSchedule {
  OperatingSchedule({
    this.weeklyOperations,
    this.daywiseOperations,
  });

  WeeklyOperations? weeklyOperations;
  dynamic daywiseOperations;

  factory OperatingSchedule.fromJson(final Map<String, dynamic> json) =>
      OperatingSchedule(
        weeklyOperations: WeeklyOperations.fromJson(
            json["weeklyOperations"] as Map<String, dynamic>),
        daywiseOperations: json["daywiseOperations"],
      );

  Map<String, dynamic> toJson() => {
        "weeklyOperations": weeklyOperations!.toJson(),
        "daywiseOperations": daywiseOperations,
      };
}

class WeeklyOperations {
  WeeklyOperations({
    this.startDayOfWeek,
    this.endDayOfWeek,
    this.operatingShifts,
  });

  String? startDayOfWeek;
  String? endDayOfWeek;
  List<OperatingShift>? operatingShifts;

  factory WeeklyOperations.fromJson(final Map<String, dynamic> json) =>
      WeeklyOperations(
        startDayOfWeek: json["startDayOfWeek"] as String,
        endDayOfWeek: json["endDayOfWeek"] as String,
        operatingShifts: List<OperatingShift>.from(json["operatingShifts"].map(
                (final x) => OperatingShift.fromJson(x as Map<String, dynamic>))
            as Iterable<dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "startDayOfWeek": startDayOfWeek,
        "endDayOfWeek": endDayOfWeek,
        "operatingShifts":
            List<dynamic>.from(operatingShifts!.map((final x) => x.toJson())),
      };
}

class OperatingShift {
  OperatingShift({
    this.name,
    this.opens,
    this.closes,
  });

  String? name;
  String? opens;
  String? closes;

  factory OperatingShift.fromJson(final Map<String, dynamic> json) =>
      OperatingShift(
        name: json["name"] as String,
        opens: json["opens"] as String,
        closes: json["closes"] as String,
      );

  Map<String, dynamic> toJson() => {
        "name": name,
        "opens": opens,
        "closes": closes,
      };
}

// class Setting {
//   Setting({
//     this.uuid,
//     this.createdBy,
//     this.updatedBy,
//     this.key,
//     this.value,
//     this.active,
//     this.createdTs,
//     this.updatedTs,
//     this.version,
//   });

//   String? uuid;
//   String? createdBy;
//   String? updatedBy;
//   String? key;
//   String? value;
//   bool? active;
//   String? createdTs;
//   String? updatedTs;
//   int? version;

//   factory Setting.fromJson(final Map<String, dynamic> json) => Setting(
//         uuid: json["uuid"],
//         createdBy: json["createdBy"] == null ? null : json["createdBy"],
//         updatedBy: json["updatedBy"] == null ? null : json["updatedBy"],
//         key: json["key"],
//         value: json["value"],
//         active: json["active"],
//         createdTs: json["createdTS"] == null ? null : json["createdTS"],
//         updatedTs: json["updatedTS"] == null ? null : json["updatedTS"],
//         version: json["version"] == null ? null : json["version"],
//       );

//   Map<String, dynamic> toJson() => {
//         "uuid": uuid,
//         "createdBy": createdBy == null ? null : createdBy,
//         "updatedBy": updatedBy == null ? null : updatedBy,
//         "key": key,
//         "value": value,
//         "active": active,
//         "createdTS": createdTs == null ? null : createdTs,
//         "updatedTS": updatedTs == null ? null : updatedTs,
//         "version": version == null ? null : version,
//       };
// }

// class Tag {
//   Tag({
//     this.uuid,
//     this.name,
//     this.slug,
//     this.auto,
//     this.replicate,
//     this.active,
//   });

//   String uuid;
//   String name;
//   String slug;
//   bool auto;
//   bool replicate;
//   bool active;

//   factory Tag.fromJson(final Map<String, dynamic> json) => Tag(
//         uuid: json["uuid"],
//         name: json["name"],
//         slug: json["slug"],
//         auto: json["auto"],
//         replicate: json["replicate"],
//         active: json["active"],
//       );

//   Map<String, dynamic> toJson() => {
//         "uuid": uuid,
//         "name": name,
//         "slug": slug,
//         "auto": auto,
//         "replicate": replicate,
//         "active": active,
//       };
// }

class UserCommunityMetadata {
  UserCommunityMetadata({
    this.mdGroupChannelUrl,
  });

  String? mdGroupChannelUrl;

  factory UserCommunityMetadata.fromJson(final Map<String, dynamic> json) =>
      UserCommunityMetadata(
        mdGroupChannelUrl: json["mdGroupChannelUrl"] as String?,
      );

  Map<String, dynamic> toJson() => {
        "mdGroupChannelUrl": mdGroupChannelUrl,
      };
}

enum Status { APPROVED, FOLLOWING, REMOVED }

final statusValues = EnumValues({
  "APPROVED": Status.APPROVED,
  "FOLLOWING": Status.FOLLOWING,
  "REMOVED": Status.REMOVED
});

class UserCommunityRole {
  UserCommunityRole({
    this.uuid,
    this.role,
    this.owner,
  });

  String? uuid;
  String? role;
  bool? owner;

  factory UserCommunityRole.fromJson(final Map<String, dynamic> json) =>
      UserCommunityRole(
        uuid: json["uuid"] as String?,
        role: json["role"] as String?,
        owner: json["owner"] == null ? null : json["owner"] as bool?,
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "role": role,
        "owner": owner == null ? null : owner,
      };
}

// class EnumValues<T> {
//   Map<String, T> map;
//   Map<T, String> reverseMap;

//   EnumValues(this.map);

//   Map<T, String> get reverse {
//     if (reverseMap == null) {
//       reverseMap = map.map((final k, final v) => new MapEntry(v, k));
//     }
//     return reverseMap;
//   }
// }
