part of kitcod_uikit_flutter;

class BottomSheetOption extends StatelessWidget {
  const BottomSheetOption({
    required this.heading,
    required this.description,
    required this.icon,
    this.iconColor,
    this.iconBackgroundColor,
    this.headingStyle,
    this.descriptionStyle,
    this.height = 40,
    final Key? key,
  }) : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //
  final String heading;
  final String description;
  final IconData icon;
  final TextStyle? headingStyle;
  final TextStyle? descriptionStyle;
  final Color? iconColor;
  final Color? iconBackgroundColor;
  final double? height;

// -------------------------------- BUILD FUNCTION -------------------------------- //
  @override
  Container build(final context) => Container(
        height: height,
        alignment: Alignment.center,
        child: Row(
          children: [
            SizedBox(
              child: Ink(
                width: 35,
                height: 35,
                decoration: ShapeDecoration(
                  color: iconBackgroundColor ?? Colors.indigo.shade50,
                  shape: const CircleBorder(),
                ),
                child: Icon(
                  icon,
                  color: iconColor ?? Colors.black,
                  size: 19,
                ),
              ),
            ),
            Column(
              mainAxisAlignment: MainAxisAlignment.center,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                Flexible(
                  child: Padding(
                      padding: const EdgeInsets.only(left: 8),
                      child: Text(heading,
                          style: headingStyle ??
                              const TextStyle(
                                  color: Colors.black, fontSize: 15))),
                ),
                Padding(
                    padding: const EdgeInsets.only(left: 8),
                    child: Text(description,
                        style: descriptionStyle ??
                            const TextStyle(color: Colors.grey))),
              ],
            ),
          ],
        ),
      );
}
