part of kitcod_uikit_flutter;

class ProfileBottomSheet extends StatelessWidget {
  const ProfileBottomSheet({
    required this.optionsHeading,
    required this.profileImageUrl,
    required this.name,
    required this.userName,
    required this.groupTags,
    this.nameStyle,
    this.userNameStyle,
    this.groupTagsStyle,
    this.postedToString,
    this.groupsArray,
    final Key? key,
  }) : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //
  final List<String> groupTags;
  final List<FeedGroup>? groupsArray;
  final Text optionsHeading;
  final String name;
  final String userName;
  final String profileImageUrl;
  final String? postedToString;
  final TextStyle? nameStyle;
  final TextStyle? groupTagsStyle;
  final TextStyle? userNameStyle;

// -------------------------------- BUILD FUNCTION -------------------------------- //
  @override
  TextButton build(final BuildContext context) => TextButton(
        onPressed: () => showModalBottomSheet(
            shape: const RoundedRectangleBorder(
                borderRadius: BorderRadius.vertical(
              top: Radius.circular(20),
            )),
            isScrollControlled: true,
            context: context,
            builder: (final context) => Container(
                padding: const EdgeInsets.all(8),
                height: MediaQuery.of(context).size.height * 0.9,
                child: Column(
                  children: [
                    Container(
                      alignment: Alignment.center,
                      child: SizedBox(
                        width: MediaQuery.of(context).size.width * 0.15,
                        height: 3,
                        child: DecoratedBox(
                          decoration:
                              BoxDecoration(color: Colors.indigo.shade100),
                        ),
                      ),
                    ),
                    Padding(
                        padding: const EdgeInsets.all(15),
                        child: optionsHeading),
                    Expanded(
                      child: ListView.builder(
                        itemCount: groupsArray!.length - 1,
                        itemBuilder: (final context, final index) =>
                            GroupDetails(
                          groupImageUrl: groupsArray![index].groupImageUrl,
                          groupTitle: groupsArray![index].groupTitle,
                          members: groupsArray![index].members,
                        ),
                      ),
                    )
                  ],
                ))),
        child: SizedBox(
          height: MediaQuery.of(context).size.height * 0.11,
          width: MediaQuery.of(context).size.width,
          child: Padding(
            padding: const EdgeInsets.all(8),
            child: ProfileDetails(
                name: name,
                nameStyle: nameStyle,
                userName: userName,
                userNameStyle: userNameStyle,
                profileImageUrl: profileImageUrl,
                groupTags: groupTags,
                groupTagsStyle: groupTagsStyle,
                postedTo: postedToString),
          ),
        ),
      );
}
