part of kitcod_uikit_flutter;

class CommentDetails extends StatelessWidget {
  const CommentDetails({
    required this.name,
    required this.profileImageUrl,
    required this.comment,
    required this.postedTime,
    this.replyOption,
    this.commentReplies,
    this.nameStyle,
    this.commentStyle,
    this.postedTimeStyle,
    final Key? key,
  }) : super(key: key);
  // -------------------------------- VARIABLES -------------------------------- //

  final String profileImageUrl;
  final String name;
  final String comment;
  final String postedTime;
  final String? replyOption;
  final List<CommentReply>? commentReplies;
  final TextStyle? nameStyle;
  final TextStyle? commentStyle;
  final TextStyle? postedTimeStyle;

  // -------------------------------- BUILD FUNCTION -------------------------------- //

  @override
  Padding build(final BuildContext context) => Padding(
        padding: const EdgeInsets.only(top: 10, left: 10, right: 10),
        child: Column(
          children: [
            Row(
              children: <Widget>[
                CircleAvatar(
                  radius: 21,
                  backgroundImage: NetworkImage(profileImageUrl),
                  backgroundColor: Colors.transparent,
                ),
                const SizedBox(width: 8),
                Flexible(
                  child: DecoratedBox(
                    decoration: BoxDecoration(
                      color: Colors.grey.shade100,
                      borderRadius: const BorderRadius.all(Radius.circular(7)),
                    ),
                    child: Padding(
                      padding: const EdgeInsets.all(10),
                      child: Column(
                        mainAxisAlignment: MainAxisAlignment.center,
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: [
                          Text(name,
                              style: nameStyle ??
                                  const TextStyle(
                                      fontSize: 15,
                                      fontWeight: FontWeight.bold,
                                      color: Colors.black)),
                          Text(comment,
                              style: commentStyle ??
                                  const TextStyle(
                                      fontSize: 15, color: Colors.black)),
                        ],
                      ),
                    ),
                  ),
                ),
              ],
            ),
            Column(
              children: [
                Padding(
                  padding: const EdgeInsets.only(left: 55, top: 10),
                  child: Row(
                    children: [
                      Text(postedTime,
                          style: postedTimeStyle ??
                              const TextStyle(
                                  color: Colors.grey, fontSize: 12)),
                      const SizedBox(width: 10),
                      if (replyOption != null)
                        Text(replyOption!,
                            style: const TextStyle(
                                color: Colors.blue, fontSize: 12))
                    ],
                  ),
                ),
                Padding(
                    padding: const EdgeInsets.only(left: 40, top: 10),
                    child: Column(children: [
                      if (commentReplies != null)
                        for (var reply in commentReplies!)
                          CommentDetails(
                            comment: reply.comment,
                            name: reply.name,
                            profileImageUrl: reply.profileImageUrl,
                            postedTime: reply.postedTime,
                          )
                    ]))
              ],
            ),
          ],
        ),
      );
}
