part of kitcod_uikit_flutter;

class GroupsList extends StatelessWidget {
  const GroupsList({
    required this.feedGroupsArray,
    final Key? key,
  }) : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //
  final List<FeedGroup> feedGroupsArray;

  // ignore: avoid_field_initializers_in_const_classes
  final addGroup = const FeedGroup(
      groupImageUrl: "https://picsum.photos/190",
      groupTitle: "Create new",
      members: "12k members",
      membersImageUrls: []);

  // -------------------------------- BUILD FUNCTION -------------------------------- //
  @override
  Widget build(final BuildContext context) => SingleChildScrollView(
        scrollDirection: Axis.horizontal,
        child: Row(
          children: [
            TextButton(
              onPressed: () {
                Navigator.push(
                  context,
                  MaterialPageRoute(
                    builder: (final context) => CreateGroupCommunity(
                      headerView: HeaderView(
                        backgroundColor: Colors.white.withOpacity(0.1),
                        leftSideIcon: IconButton(
                          onPressed: () {
                            Navigator.pop(context);
                          },
                          icon: const Icon(
                            Icons.arrow_back_outlined,
                            color: Colors.black,
                          ),
                        ),
                        header: const Text(
                          "Create New Group",
                          style: TextStyle(color: Colors.black),
                        ),
                        headerAlignment: Alignment.centerLeft,
                      ),
                      heading: "Community Access",
                      description: "Choose who can join the community",
                    ),
                  ),
                );
              },
              child: Flex(
                direction: Axis.vertical,
                children: [
                  Container(
                    height: 74,
                    width: 74,
                    decoration: BoxDecoration(
                      boxShadow: const [
                        BoxShadow(
                          color: Colors.white54,
                          blurRadius: 5,
                          offset: Offset(0, 10),
                          spreadRadius: 0.5,
                        ),
                      ],
                      borderRadius: BorderRadius.circular(12),
                    ),
                    child: Card(
                      color: Colors.grey.shade200,
                      shape: RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(12),
                      ),
                      elevation: 4,
                      child: Center(
                        child: Icon(
                          Icons.add,
                          size: 45,
                          color: Colors.grey.shade400,
                        ),
                      ),
                    ),
                  ),
                  const SizedBox(height: 5),
                  const SizedBox(
                    width: 60,
                    child: Text(
                      "Create New Group",
                      maxLines: 2,
                      textAlign: TextAlign.center,
                      overflow: TextOverflow.fade,
                      style: TextStyle(fontSize: 12),
                    ),
                  ),
                ],
              ),
            ),
            for (var feedGroup in feedGroupsArray) groupStory(feedGroup),
          ],
        ),
      );

  // -------------------------------- UI FUNCTION -------------------------------- //
  Row groupStory(final FeedGroup feedGroup) => Row(
        children: [
          Column(
            children: [
              Container(
                height: 75,
                width: 75,
                decoration: BoxDecoration(
                  boxShadow: const [
                    BoxShadow(
                      color: Colors.white54,
                      blurRadius: 5,
                      offset: Offset(0, 10),
                      spreadRadius: 0.5,
                    ),
                  ],
                  borderRadius: BorderRadius.circular(12),
                ),
                child: Card(
                  elevation: 4,
                  shape: RoundedRectangleBorder(
                      borderRadius: BorderRadius.circular(13),
                      side: const BorderSide(width: 2, color: Colors.blue)),
                  child: Padding(
                    padding: const EdgeInsets.all(3),
                    child: ClipRRect(
                      borderRadius: BorderRadius.circular(12), // Image border
                      child: SizedBox.fromSize(
                        child: Image.network(
                          feedGroup.groupImageUrl,
                          fit: BoxFit.cover,
                          width: 70,
                          height: 70,
                        ),
                      ),
                    ),
                  ),
                ),
              ),
              const SizedBox(height: 5),
              SizedBox(
                width: 60,
                child: Text(
                  feedGroup.groupTitle,
                  maxLines: 2,
                  textAlign: TextAlign.center,
                  overflow: TextOverflow.fade,
                  style: const TextStyle(fontSize: 12),
                ),
              ),
            ],
          ),
        ],
      );
}
