part of kitcod_uikit_flutter;

class HeaderView extends StatelessWidget implements PreferredSizeWidget {
  const HeaderView({
    final Key? key,
    this.leftSideIcon,
    this.rightSideIcon,
    this.header,
    this.headerAlignment = Alignment.center,
    this.backgroundColor,
  }) : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //
  final Widget? leftSideIcon;
  final Widget? rightSideIcon;
  final Text? header;
  final Alignment headerAlignment;
  final Color? backgroundColor;

  // -------------------------------- BUILD FUNCTION -------------------------------- //
  @override
  AppBar build(final context) => AppBar(
        backgroundColor: backgroundColor,
        leading: leftSideIcon,
        title: Align(alignment: headerAlignment, child: header),
        elevation: 0,
        actions: rightSideIcon == null ? null : [rightSideIcon!],
      );

  @override
  Size get preferredSize => const Size.fromHeight(kToolbarHeight);
}
