part of kitcod_uikit_flutter;

class ProfileDetails extends StatelessWidget {
  const ProfileDetails({
    required this.name,
    required this.userName,
    required this.profileImageUrl,
    required this.groupTags,
    this.nameStyle,
    this.userNameStyle,
    this.groupTagsStyle,
    this.postedTo,
    final Key? key,
  }) : super(key: key);
  // -------------------------------- VARIABLES -------------------------------- //

  final List<String> groupTags;
  final String profileImageUrl;
  final String name;
  final String userName;
  final String? postedTo;
  final TextStyle? nameStyle;
  final TextStyle? groupTagsStyle;
  final TextStyle? userNameStyle;

  // -------------------------------- BUILD FUNCTION -------------------------------- //

  @override
  SizedBox build(final BuildContext context) => SizedBox(
      width: MediaQuery.of(context).size.width,
      child: Row(
        children: [
          CircleAvatar(
            radius: 21,
            backgroundImage: NetworkImage(profileImageUrl),
            backgroundColor: Colors.transparent,
          ),
          Column(
            mainAxisAlignment: MainAxisAlignment.center,
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              Padding(
                padding: const EdgeInsets.only(left: 10),
                child: RichText(
                  text: TextSpan(
                      text: name,
                      style: nameStyle ??
                          const TextStyle(
                              fontSize: 15,
                              fontWeight: FontWeight.bold,
                              color: Colors.black),
                      children: <TextSpan>[
                        TextSpan(
                          text: " $userName",
                          style: userNameStyle ??
                              const TextStyle(
                                  fontSize: 15,
                                  color: Colors.grey,
                                  fontWeight: FontWeight.normal),
                        )
                      ]),
                ),
              ),
              Container(
                padding: const EdgeInsets.only(left: 10),
                width: MediaQuery.of(context).size.width * 0.6,
                child: Wrap(
                  children: <Widget>[
                    if (postedTo != null)
                      Text(postedTo!,
                          style: const TextStyle(color: Colors.grey)),
                    for (var tag in groupTags)
                      Text("$tag ",
                          style: groupTagsStyle ??
                              const TextStyle(color: Colors.indigo))
                  ],
                ),
              )
            ],
          ),
        ],
      ));
}
