part of kitcod_uikit_flutter;

class TextBarButton extends StatelessWidget {
  const TextBarButton({
    required this.name,
    required this.userName,
    required this.profileImageUrl,
    required this.groupTags,
    required this.groupList,
    required this.hintText,
    required this.moreOptions,
    this.postType,
    this.nameStyle,
    this.userNameStyle,
    this.groupTagsStyle,
    this.hintTextStyle,
    this.icon,
    this.iconColor,
    this.iconBackgroundColor,
    this.headingStyle,
    this.descriptionStyle,
    this.groupsList,
    final Key? key,
  }) : super(key: key);
  // -------------------------------- VARIABLES -------------------------------- //

  final String hintText;
  final String name;
  final String userName;
  final String profileImageUrl;
  final List<String> groupTags;
  final List<FeedGroup> groupList;
  final TextStyle? hintTextStyle;
  final IconData? icon;
  final Color? iconColor;
  final Color? iconBackgroundColor;
  final TextStyle? headingStyle;
  final TextStyle? descriptionStyle;
  final List<PostType>? postType;
  final List<FeedGroup>? groupsList;
  final TextStyle? nameStyle;
  final TextStyle? groupTagsStyle;
  final TextStyle? userNameStyle;
  final List<MoreOptions> moreOptions;

  // -------------------------------- BUILD FUNCTION -------------------------------- //

  @override
  TextButton build(final BuildContext context) => TextButton(
        onPressed: () => {
          showModalBottomSheet(
            isScrollControlled: true,
            shape: const RoundedRectangleBorder(
                borderRadius: BorderRadius.vertical(
              top: Radius.circular(20),
            )),
            context: context,
            builder: (final context) => Container(
                padding: const EdgeInsets.all(8),
                child: BottomSheetDropdown(
                  heading: "Select post type",
                  groupList: groupList,
                  postType: postType ??
                      [PostType.announcement, PostType.poll, PostType.post],
                  iconColor: iconColor,
                  iconBackgroundColor: iconBackgroundColor,
                  headingStyle: headingStyle,
                  descriptionStyle: descriptionStyle,
                  nameStyle: nameStyle,
                  userNameStyle: userNameStyle,
                  groupTagsStyle: groupTagsStyle,
                  groupTags: groupTags,
                  hintText: hintText,
                  icon: icon,
                  moreOptions: moreOptions,
                  name: name,
                  profileImageUrl: profileImageUrl,
                  userName: userName,
                  groupsList: groupList,
                  hintTextStyle: hintTextStyle,
                )),
          ),
        },
        child: Padding(
          padding: const EdgeInsets.all(10),
          child: Container(
            alignment: Alignment.centerLeft,
            height: MediaQuery.of(context).size.height * 0.06,
            width: MediaQuery.of(context).size.width,
            decoration: BoxDecoration(
                border: Border.all(
                  color: Colors.grey,
                ),
                borderRadius: const BorderRadius.all(Radius.circular(20))),
            child: Padding(
              padding: const EdgeInsets.symmetric(horizontal: 10),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  Text(hintText,
                      style:
                          hintTextStyle ?? const TextStyle(color: Colors.grey)),
                  Icon(icon ?? Icons.camera_alt_outlined,
                      color: iconColor ?? Colors.grey)
                ],
              ),
            ),
          ),
        ),
      );
}
