part of kitcod_uikit_flutter;

class VideoWidget extends StatefulWidget {
  const VideoWidget({
    required this.videoPlayerController,
    required this.looping,
    required this.autoplay,
    final Key? key,
  }) : super(key: key);
  // -------------------------------- VARIABLES -------------------------------- //

  final VideoPlayerController videoPlayerController;
  final bool looping;
  final bool autoplay;

  @override
  _VideoWidgetState createState() => _VideoWidgetState();
}

// -------------------------------- UI FUNCTIONS -------------------------------- //

class _VideoWidgetState extends State<VideoWidget> {
  late ChewieController _chewieController;

  @override
  void initState() {
    super.initState();
    _chewieController = ChewieController(
      videoPlayerController: widget.videoPlayerController,
      aspectRatio: 16 / 9,
      autoInitialize: true,
      autoPlay: widget.autoplay,
      looping: widget.looping,
      deviceOrientationsAfterFullScreen: [DeviceOrientation.portraitUp],
      errorBuilder: (final context, final errorMessage) => Center(
        child: Text(
          errorMessage,
          style: const TextStyle(color: Colors.white),
        ),
      ),
    );
  }

  @override
  void dispose() {
    super.dispose();
    _chewieController.dispose();
  }

  // -------------------------------- BUILD FUNCTION -------------------------------- //

  @override
  Widget build(final BuildContext context) => ClipRRect(
        borderRadius: BorderRadius.circular(15),
        child: SizedBox(
          height: MediaQuery.of(context).size.height * 0.22,
          child: Chewie(
            controller: _chewieController,
          ),
        ),
      );
}
