part of kitcod_uikit_flutter;

class MyGroups extends StatelessWidget {
  const MyGroups({
    required this.headerView,
    required this.groupsList,
    this.titleStyle,
    this.membersStyle,
    final Key? key,
  }) : super(key: key);
  // -------------------------------- VARIABLES -------------------------------- //

  final HeaderView headerView;
  final List<FeedGroup> groupsList;
  final TextStyle? titleStyle;
  final TextStyle? membersStyle;

  // -------------------------------- UI FUNCTIONS -------------------------------- //

  Container _headerWidget(final BuildContext context) => Container(
        padding: const EdgeInsets.all(20),
        child: Column(
          children: [
            for (FeedGroup groupItem in groupsList)
              GroupDetails(
                groupImageUrl: groupItem.groupImageUrl,
                groupTitle: groupItem.groupTitle,
                members: groupItem.members,
                groupTitleStyle: titleStyle ??
                    const TextStyle(
                        color: Colors.black,
                        fontWeight: FontWeight.bold,
                        fontSize: 15),
                membersStyle:
                    membersStyle ?? const TextStyle(color: Colors.grey),
              )
          ],
        ),
      );

  // -------------------------------- BUILD FUNCTION -------------------------------- //
  @override
  Widget build(final context) => Scaffold(
        appBar: headerView,
        body: SingleChildScrollView(
          child: Column(children: [
            _headerWidget(context),
          ]),
        ),
      );
}
